improve DASD parameters handling in normalize_dasd_arg (#824807)

This commit is contained in:
Dan Horák 2012-05-25 09:04:27 +02:00
parent 8c7c2bc4db
commit 0355cd14d3
2 changed files with 81 additions and 70 deletions

View File

@ -39,7 +39,13 @@ function canonicalize_devno()
}
read DASD
for dasditem in $(echo $DASD |sed 's/,/ /g')
# See if we've gotten a format like <dev>,feature or <dev>,<dev>,<dev>
[[ "$DASD" =~ (\,*=[[:digit:]]) ]]
case $? in
# case of 0 is features, just turn the comma into a space
0) echo $DASD |sed 's/,/ /g';;
*) # We've got no features, do things normally
for dasditem in $(echo $DASD |sed 's/,/ /g')
do
unset range features lo hi attrs devno lodevno hidevno devbusid sys
case $dasditem in
@ -54,7 +60,7 @@ for dasditem in $(echo $DASD |sed 's/,/ /g')
0) # string matched the pattern
lo=$(canonicalize_devno $lo) ;;
1) # string did not match the pattern
echo $"Incorrect format for lower bound of DASD range $range: $lo"
echo $"Incorrect format for lower bound of DASD range $range: $lo" 1>&2
exit 1
;;
2) echo "l.$LINENO: syntax error in regex of match operator =~, code needs to be fixed" 1>&2 ;;
@ -67,12 +73,12 @@ for dasditem in $(echo $DASD |sed 's/,/ /g')
0) # string matched the pattern
hi=$(canonicalize_devno $hi)
if [ "${lo%.*}" != "${hi%.*}" ]; then
echo $"Prefixes of DASD range $range do not match: ${lo%.*} != ${hi%.*}"
echo $"Prefixes of DASD range $range do not match: ${lo%.*} != ${hi%.*}" 1>&2
exit 1
fi
;;
1) # string did not match the pattern
echo $"Incorrect format for upper bound of DASD range $range: $hi"
echo $"Incorrect format for upper bound of DASD range $range: $hi" 1>&2
exit 1
;;
2) echo "l.$LINENO: syntax error in regex of match operator =~, code needs to be fixed" 1>&2 ;;
@ -80,7 +86,7 @@ for dasditem in $(echo $DASD |sed 's/,/ /g')
esac
fi
if [ "${features//*)/}" != "" ]; then
echo $"Missing closing parenthesis at features of DASD range $range: ($features"
echo $"Missing closing parenthesis at features of DASD range $range: ($features" 1>&2
exit 1
fi
if [ -n "$features" ]; then
@ -91,7 +97,7 @@ for dasditem in $(echo $DASD |sed 's/,/ /g')
ro) attrs=$attrs" readonly" ;;
diag) attrs=$attrs" use_diag" ;;
erplog|failfast) attrs=$attrs" "$feature ;;
*) echo $"Unknown DASD feature for device range $range: $feature"
*) echo $"Unknown DASD feature for device range $range: $feature" 1>&2
exit 1
;;
esac
@ -109,4 +115,6 @@ for dasditem in $(echo $DASD |sed 's/,/ /g')
echo
done
esac
done
done
;;
esac

View File

@ -8,7 +8,7 @@ Name: s390utils
Summary: Utilities and daemons for IBM System/z
Group: System Environment/Base
Version: 1.16.0
Release: 8%{?dist}
Release: 9%{?dist}
Epoch: 2
License: GPLv2 and GPLv2+ and CPL
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
@ -867,6 +867,9 @@ User-space development files for the s390/s390x architecture.
%changelog
* Fri May 25 2012 Dan Horák <dan[at]danny.cz> 2:1.16.0-9
- improve DASD parameters handling in normalize_dasd_arg (#824807)
* Wed May 23 2012 Dan Horák <dan[at]danny.cz> 2:1.16.0-8
- add normalize_dasd_arg script (#823078)